#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

/*
 * Funkcije handler0() i handler1() bivaju pozvane po izlasku iz glavnog
 * programa.
 */
static void handler0 (void);
static void handler1 (void);

static void error_fatal (char *message);

/*
 * Program demonstrira atexit() funkciju iz standardne biblioteke.
 */
int
main (int argc, char **argv)
{
  /* Registruju se funkcije koje ce biti pozvane po zavrsetku programa. */
  if (atexit (handler0) != 0)
    error_fatal (argv[0]);
  if (atexit (handler0) != 0)
    error_fatal (argv[0]);
  if (atexit (handler1) != 0)
    error_fatal (argv[0]);

  /* Program se oglasava porukom na standardnom izlazu. */
  printf ("main program executing\n");

  /* Zavrsava se program. */
  exit (EXIT_SUCCESS);
}

static void
handler0 (void)
{
  /* Funkcija se oglasava odgovarajucom porukom na standardnom izlazu. */
  printf ("handler 0 called\n");
}

static void
handler1 (void)
{
  /* Funkcija se oglasava odgovarajucom porukom na standardnom izlazu. */
  printf ("handler 1 called\n");
}

static void
error_fatal (char *message)
{
  perror (message);

  exit (EXIT_FAILURE);
}
